diff --git a/src/utils_tail_match.c b/src/utils_tail_match.c
index 79868fcdf9..231738b86f 100644
--- a/src/utils_tail_match.c
+++ b/src/utils_tail_match.c
@@ -118,10 +118,10 @@ static int latency_submit_match(cu_match_t *match, void *user_data) {
   sstrncpy(vl.type, data->type, sizeof(vl.type));
   for (size_t i = 0; i < data->latency_config.percentile_num; i++) {
     if (strlen(data->type_instance) != 0)
-      snprintf(vl.type_instance, sizeof(vl.type_instance), "%.117s-%.2f",
+      snprintf(vl.type_instance, sizeof(vl.type_instance), "%.50s-%.4g",
                data->type_instance, data->latency_config.percentile[i]);
     else
-      snprintf(vl.type_instance, sizeof(vl.type_instance), "%.0f",
+      snprintf(vl.type_instance, sizeof(vl.type_instance), "%.4g",
                data->latency_config.percentile[i]);
 
     vl.values = &(value_t){
@@ -151,10 +151,10 @@ static int latency_submit_match(cu_match_t *match, void *user_data) {
 
     if (strlen(data->type_instance) != 0)
       snprintf(vl.type_instance, sizeof(vl.type_instance),
-               "%.54s-%.54s-%.2g_%.2g", data->type, data->type_instance,
+               "%.50s-%.50s-%g_%g", data->type, data->type_instance,
                lower_bound, upper_bound);
     else
-      snprintf(vl.type_instance, sizeof(vl.type_instance), "%.107s-%.2g_%.2g",
+      snprintf(vl.type_instance, sizeof(vl.type_instance), "%.50s-%g_%g",
                data->type, lower_bound, upper_bound);
 
     vl.values = &(value_t){
